package com.byteslounge.servlet;

import java.io.IOException;

import javax.naming.InitialContext;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.byteslounge.ejb.TestingPassivation;
import com.byteslounge.model.TestingObject;

@WebServlet(name = "testingServlet", urlPatterns = {"/testing"})
public class TestingServlet extends HttpServlet {

	private static final long serialVersionUID = 1L;

	protected void doGet(HttpServletRequest request,
		    HttpServletResponse response)
		    throws ServletException, IOException {
		
		InitialContext ic;
		TestingPassivation testingPassivation;
		
		String beanCountParam = request.getParameter("count");
		
		if(beanCountParam != null){
			int beanCount = Integer.parseInt(beanCountParam);
			
			try{
				ic = new InitialContext();
				for(int i = 0; i < beanCount; i++){
					testingPassivation = (TestingPassivation)
						ic.lookup("java:global/com-byteslounge/com-bytesloungeejb/TestingPassivationBean");
					
					testingPassivation.setTestingObject(new TestingObject("bean" + i));
					
					request.getSession().setAttribute("bean" + i, testingPassivation);
				}
			} catch(Exception e){
				throw new ServletException(e);
			}
		}
		
		String beanIndex = request.getParameter("activate");
		
		if(beanIndex != null){
			try{
				ic = new InitialContext();
			
				testingPassivation = (TestingPassivation)
					request.getSession().getAttribute("bean" + beanIndex);
				
				System.out.println("TestingObject property value: " 
					+ testingPassivation.getTestingObject().getTestingProperty());
				
			} catch(Exception e){
				throw new ServletException(e);
			}
		}
	}
}
